<template>
  <v-container>
    <v-form>
      <v-container>
        <v-row>
          <v-col cols="12" md="4">
            <v-text-field
              v-model="code"
              :counter="10"
              label="Code"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              v-model="name"
              :counter="10"
              label="Name"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-text-field
              v-model="email"
              :counter="10"
              label="Email"
              required
            ></v-text-field>
          </v-col>

          <v-col cols="12" md="4">
            <v-btn @click="doQuery"><v-icon>mdi-magnify</v-icon> Search</v-btn>
            <v-btn @click="doAdd"><v-icon>mdi-plus</v-icon>Add</v-btn>
          </v-col>
        </v-row>
      </v-container>
    </v-form>

    <v-simple-table>
      <template v-slot:default>
        <thead>
          <tr>
            <th class="text-left">#</th>
            <th class="text-left">Code</th>
            <th class="text-left">Email</th>
            <th class="text-left">Operate</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="usr in users" :key="usr.id">
            <td>{{ usr.id }}</td>
            <td>{{ usr.code }}</td>
            <td>{{ usr.email }}</td>
            <td>
              <v-btn @click="doDelete(usr.id)">Del</v-btn>
              <v-btn @click="doEdit(usr.id)">Edit</v-btn>
            </td>
          </tr>
        </tbody>
      </template>
    </v-simple-table>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapActions, mapGetters } from 'vuex'
export default Vue.extend({
  data() {
    return {
      code: '',
      name: '',
      email: '',
    }
  },
  computed: mapGetters({
    users: 'user/users',
  }),
  methods: {
    doQuery() {
      this.queryUser({ code: this.code, email: this.email, name: this.name })
    },
    doAdd() {
      this.$router.push('/user')
    },
    doDelete(id: number) {
      this.deleteUser(id).then((_) => this.doQuery())
    },
    doEdit(id: number) {
      this.getUserById(id).then((_) => this.$router.push('/user'))
    },
    ...mapActions({
      queryUser: 'user/queryUser',
      deleteUser: 'user/deleteUser',
      getUserById: 'user/getUserById',
    }),
  },
  mounted() {
    this.doQuery()
  },
})
</script>